/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2004/11/02 11:12:33 $ $Revision: 1.21 $ */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#ifndef RPN_H
#define RPN_H

#define RpnT_Const	1
#define RpnT_Var	2
#define RpnT_Unary	3
#define RpnT_Binary	4
#define RpnT_Function	5
#define RpnT_ArrayFunc	6
#define RpnT_ArrayEnd	7
#define RpnT_SecEnd	8
#define RpnT_PartParam	9
#define RpnT_ArrayVar	10
#define RpnT_GlobalVar	11
#define RpnT_Text	12
#define RpnT_GlobalVar2	13

typedef struct vect_ {
  double v[3];
} vect;

typedef struct RPN_ {
  int rpn;		/* 1 if already converted */
  int type;		/* see RpnT_... */
  int rank;		/* rank in resolve order */
  int vect;		/* 1 if object is vector */
  double dval;		/* floating point value */
  vect val;		/* floating point value */
  int ival;		/* integer value */
  int arrnum;		/* array num */
  struct RPN_ *next;	/* next eleement */
} RPN;

RPN *rpnroot;
#define RPN_StrLen	10	/* String length of function arrays */
#define RPN_ConstNum	11	/* number of constants */
#define RPN_VConstNum	29	/* number of vector constants */
#define RPN_UONum	19	/* unary operator number */
#define RPN_FNum	8	/* function number */
#define RPN_ArrFNum	7	/* array function number */
#define RPN_ArrVNum	1	/* array variable number */
#define RPN_BINNUM	17	/* binary operator number */
#define CEF_PARNUM	21	/* number of parameter types */
#define CEF_SUBPARNUM	5	/* number of subparameters */

typedef const char RPN_strtype[][RPN_StrLen];

extern const char RPN_unaryoperator[RPN_UONum][RPN_StrLen];
extern const char RPN_function[RPN_FNum][RPN_StrLen];
extern const char RPN_arrayfunction[RPN_ArrFNum][RPN_StrLen];
extern const char RPN_parvectstr[CEF_PARNUM][RPN_StrLen];
extern const char RPN_parstr[CEF_PARNUM][CEF_SUBPARNUM][5];
extern const char RPN_binaryoperator[RPN_BINNUM][RPN_StrLen];
extern const int  RPN_binoporder[RPN_BINNUM];
extern const char RPN_partparam[RPN_StrLen];
extern const char RPN_const[RPN_ConstNum][RPN_StrLen];
extern const double RPN_constval[RPN_ConstNum];
extern const char RPN_vconst[RPN_VConstNum][RPN_StrLen];
extern const double RPN_vconstval[RPN_VConstNum][3];
int RPN_deg;
int RPN_arrayvar;
int RPN_arrayfunc;

#define RpnVT_Constr	1
#define RpnVT_Time	2
extern const double RP;

#endif

